10 CLS : PRINT "Byers, J.A. 1992. Optimal fractionation and bioassay plans for isolation of"
20 PRINT "    synergistic chemicals: the subtractive-combination method. J. Chem. Ecol."
30 PRINT "    18:1603-1621."
40 PRINT : INPUT "Enter # fractions (2 to 100)"; N
50 N = INT(N): IF N > 100 OR N < 2 THEN SOUND 50, 1: GOTO 40
60 INPUT "Enter # synergists (2 to 5)"; R
70 R = INT(R): IF R > 5 OR R < 2 THEN SOUND 50, 1: GOTO 60
80 INPUT "Enter total # compounds in ext."; CP: CP = INT(CP)
90 IF CP < N THEN SOUND 50, 1: GOTO 80
100 DIM W$(21), A(100), B(100), C(100), D(100), E(100), F(100), G(100)
110 DATA "N","P:1","P:2","P:3","P:4","P:5","P:1+1","P:1+1+1","P:1+1+1+1"
120 DATA "P:1+1+1+1+1","P:2+1","P:3+1","P:2+1+1","P:2+2","P:4+1","P:3+2"
130 DATA "P:3+1+1","P:2+2+1","P:2+1+1+1","Subtractive","Additive"
140 FOR Q = 1 TO 21: READ W$(Q): NEXT: IF R = 2 THEN 160 ELSE IF R = 3 THEN 210
150 IF R = 4 THEN 320 ELSE IF R = 5 THEN 470
160 PRINT TAB(3); W$(1); TAB(10); W$(3); TAB(20); W$(7); TAB(30); W$(20); TAB(45); W$(21)
170 FOR X = R TO N: I = 2: J = 1: GOSUB 700: CD = INT(CP / X + .5)
180 SU = 1 + X + P * CD + H * 2 * CD: AD = 1 + P * X: J = X: K = 2: GOSUB 760
190 AD = AD + H * W: J = CD: K = 2: GOSUB 760: AD = AD + P * W + H * 2 * CD
200 PRINT TAB(1); X; TAB(10); P; TAB(20); H; TAB(30); SU; TAB(45); AD: NEXT X: GOTO 790
210 PRINT TAB(3); W$(1); TAB(10); W$(4); TAB(20); W$(11); TAB(30); W$(8);
220 PRINT TAB(40); W$(20); TAB(55); W$(21)
230 FOR X = R TO N: I = 3: J = 1: GOSUB 700: A(X) = P: C(X) = H
240 I = 2: J = 2: GOSUB 700: B(X) = P: CD = INT(CP / X + .5)
250 SU = 1 + X + A(X) * CD + B(X) * 2 * CD + C(X) * 3 * CD
260 AD = 1 + A(X) * X
270 K = 2: J = X: GOSUB 760: AD = AD + B(X) * W: K = 3: J = X: GOSUB 760: AD = AD + C(X) * W
280 K = 3: J = CD: GOSUB 760: AD = AD + A(X) * W
290 K = 2: J = CD: GOSUB 760: AD = AD + B(X) * (W + CD) + C(X) * 3 * CD
300 PRINT TAB(2); X; TAB(9); A(X); TAB(20); B(X); TAB(30); C(X); TAB(40); SU; TAB(55); AD
310 NEXT X: GOTO 790
320 PRINT TAB(3); W$(1); TAB(8); W$(5); TAB(16); W$(12); TAB(24); W$(13);
330 PRINT TAB(34); W$(14); TAB(42); W$(9); TAB(54); W$(20); TAB(68); W$(21)
340 FOR X = R TO N: I = 4: J = 1: GOSUB 700
350 A(X) = P: E(X) = H: I = 3: J = 2: GOSUB 700: B(X) = P: I = 2: J = 3: GOSUB 700: C(X) = P
360 P = (R * (R - 1) / 2) * (X * (X - 1)) / 2 / X ^ R
370 P = INT((P - INT(P)) * 1000 + .5) / 1000 + INT(P): D(X) = P: CD = INT(CP / X + .5)
380 SU = 1 + X + A(X) * CD + B(X) * 2 * CD + C(X) * 3 * CD + D(X) * 2 * CD + E(X) * 4 * CD
390 AD = 1 + A(X) * X
400 K = 2: J = X: GOSUB 760: AD = AD + B(X) * W: K = 2: J = X: GOSUB 760: AD = AD + D(X) * W
410 K = 3: J = X: GOSUB 760: AD = AD + C(X) * W: K = 4: J = X: GOSUB 760: AD = AD + E(X) * W
420 K = 4: J = CD: GOSUB 760: AD = AD + A(X) * W: K = 3: J = CD: GOSUB 760: AD = AD + B(X) * (W + CD)
430 K = 2: J = CD: GOSUB 760: AD = AD + D(X) * 2 * W
440 K = 2: J = CD: GOSUB 760: AD = AD + C(X) * (W + 2 * CD) + E(X) * 4 * CD
450 PRINT TAB(2); X; TAB(7); A(X); TAB(15); B(X); TAB(23); C(X); TAB(33); D(X);
460 PRINT TAB(41); E(X); TAB(53); SU; TAB(67); AD: NEXT X: GOTO 790
470 PRINT TAB(2); W$(1); TAB(5); W$(6); TAB(10); W$(15); TAB(17); W$(16); TAB(24); W$(17);
480 PRINT TAB(33); W$(18); TAB(42); W$(19); TAB(53); W$(10);
490 PRINT TAB(66); "Sub."; TAB(72); "Add."
500 FOR X = R TO N: I = 5: J = 1: GOSUB 700: A(X) = P: G(X) = H: I = 4: J = 2
510 GOSUB 700: B(X) = P: I = 3: J = 2: GOSUB 700: C(X) = P: I = 3: J = 3: GOSUB 700
520 D(X) = P: I = 2: J = 4: GOSUB 700: F(X) = P
530 P = (X * (X - 1) / 2) * (R * (R - 1) / 2) * 3 * (X - 2) / X ^ R
540 P = INT((P - INT(P)) * 1000 + .5) / 1000 + INT(P): E(X) = P: CD = INT(CP / X + .5)
550 SU = 1 + X + A(X) * CD + B(X) * 2 * CD + C(X) * 2 * CD + D(X) * 3 * CD
560 SU = SU + E(X) * 3 * CD + F(X) * 4 * CD + G(X) * 5 * CD
570 AD = 1 + A(X) * X
580 K = 2: J = X: GOSUB 760: AD = AD + B(X) * W: K = 2: J = X: GOSUB 760: AD = AD + C(X) * W
590 K = 3: J = X: GOSUB 760: AD = AD + D(X) * W: K = 3: J = X: GOSUB 760: AD = AD + E(X) * W
600 K = 4: J = X: GOSUB 760: AD = AD + F(X) * W: K = 5: J = X: GOSUB 760: AD = AD + G(X) * W
610 K = 5: J = CD: GOSUB 760: AD = AD + A(X) * W
620 K = 4: J = CD: GOSUB 760: AD = AD + B(X) * (W + CD)
630 K = 3: J = CD: GOSUB 760: AD = AD + C(X) * W: K = 2: J = CD: GOSUB 760: AD = AD + C(X) * W
640 K = 3: J = CD: GOSUB 760: AD = AD + D(X) * (W + 2 * CD)
650 K = 2: J = CD: GOSUB 760: AD = AD + E(X) * W
660 K = 2: J = CD: GOSUB 760: AD = AD + E(X) * (W + CD)
670 K = 2: J = CD: GOSUB 760: AD = AD + F(X) * (W + 3 * CD) + G(X) * 5 * CD
680 PRINT X; TAB(5); A(X); TAB(11); B(X); TAB(18); C(X); TAB(26); D(X); TAB(34); E(X);
690 PRINT TAB(42); F(X); TAB(52); G(X); TAB(60); SU; TAB(70); AD: NEXT X: GOTO 790
700 NF = 1: Z = X: FOR G = 1 TO J: NF = NF * Z: Z = Z - 1: NEXT
710 RF = 1: FOR G = 1 TO R: RF = RF * G: NEXT: FI = 1: FOR G = 1 TO I: FI = FI * G: NEXT
720 RI = 1: FOR G = 1 TO R - I: RI = RI * G: NEXT
730 P = (RF / (FI * RI)) * NF / X ^ R: P = INT((P - INT(P)) * 1000 + .5) / 1000 + INT(P)
740 Z = X: NF = 1: FOR G = 1 TO R: NF = NF * Z: Z = Z - 1: NEXT
750 H = NF / X ^ R: H = INT((H - INT(H)) * 1000 + .5) / 1000 + INT(H): RETURN
760 W = 0: FOR I = 1 TO K: JJ = J
770 FG = 1: FOR G = 1 TO I: FG = JJ * FG: JJ = JJ - 1: NEXT
780 RG = 1: FOR G = 1 TO I: RG = RG * G: NEXT: CW = FG / RG: W = CW + W: NEXT I: RETURN
790 PRINT "PRESS [Print Scrn] key to print screen";
800 A$ = INKEY$: IF A$ = "" THEN GOTO 800

